import React from 'react';
import DropdownContext from './DropdownContext';

function DropdownToggle(_ref) {
  var children = _ref.children;
  return React.createElement(DropdownContext.Consumer, null, function (_ref2) {
    var show = _ref2.show,
        onToggle = _ref2.onToggle,
        toggleRef = _ref2.toggleRef;
    return children({
      show: show,
      onToggle: onToggle,
      props: {
        'aria-haspopup': true,
        'aria-expanded': !!show
      },
      ref: toggleRef
    });
  });
}

DropdownToggle.displayName = 'ReactOverlaysDropdownToggle';
export default DropdownToggle;